%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% 2-link MonkeyBot Dynamics Simulation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Sample script file to demonstrate use of simulation code.
%  Sets up the parameters and calls the simulation function
%
%   David Ufford
%   June 2009

clear;
clear global;

global doplot;
doplot=1;  %1= displays motion as it progresses, 0=does not draw motion

%%%%%%%%%%%%%%%
%% System Parameters

M(1)=3.083276839957533;%mass of links
M(2)=3.083276839957533;
L(1)=0.610; %length of links
L(2)=0.610;
I(1)=5.386568898408416e-2;  %rot interia of links about CG
I(2)=5.386568898408416e-2;
R(1)=L(1)-6.37687066165708e-2;  %distance of CG1 from top point of system
R(2)=6.37687066165708e-2;%distance of CG2 from center point
g=9.81;%gravity
%Note: above sample parametes obtained from "A five-link 2D brachiating ape model with
%life-like zero-energy-cost motions" Mario W. Gomes, Andy L. Ruina 15 April

%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Initial Conditions
%q = [x y t1 t2 dx dy dt1 dt2]';

Q0=zeros(8,1); 
Q0(7)=1.5505189108055; %start with some initial velocities
Q0(8)=11.733043896405-Q0(7);

Q0

%%%%%%%%%%%%%%%%%%%%
%%% Controller Parameters (for sample open-loop controller - see controlAlgorithm.m)

global motor_t; %time motor is enable at beginning of each step/cylce
global swap_t;%time until magnets are swapped (time during each cycle)
global initial_t;  %time before first cycle
global maxMotorPower; %torque applied by motor

maxMotorPower=2;
motor_t=.1;%if this is set to zero, with current parameters will get a zero-energy brachiation
swap_t=0.865;
initial_t=.433;



fprintf('swap_t/motor_t: %0.2f/%0.2f\n', swap_t,motor_t);
[final_t, final_Q]=monkeySim(Q0,4,M,I,L,R,g);
%keyboard;
